'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var Paho = _interopDefault(require('paho-mqtt'));
var xtend = _interopDefault(require('xtend/immutable'));
var EventEmitter = _interopDefault(require('@skt-t1-byungi/event-emitter'));
var xtend$1 = _interopDefault(require('xtend/mutable'));

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var Subscription =
/*#__PURE__*/
function () {
  function Subscription(topic, client) {
    _classCallCheck(this, Subscription);

    this._topic = topic;
    this._client = client;
  }

  _createClass(Subscription, [{
    key: "on",
    value: function on(listener) {
      this._client.onMessage(this._topic, listener);

      return this;
    }
  }, {
    key: "once",
    value: function once(listener) {
      this._client.once("message:".concat(this._topic), listener);

      return this;
    }
  }, {
    key: "off",
    value: function off(listener) {
      this._client.removeMessageListener(this._topic, listener);

      return this;
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe() {
      var removeListeners = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      this._client.unsubscribe(this._topic, removeListeners);

      return this;
    }
  }, {
    key: "send",
    value: function send() {
      var _this$_client;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      (_this$_client = this._client).send.apply(_this$_client, [this._topic].concat(args));

      return this;
    }
  }, {
    key: "publish",
    value: function publish() {
      this.send.apply(this, arguments);
      return this;
    }
  }, {
    key: "topic",
    get: function get() {
      return this._topic;
    }
  }]);

  return Subscription;
}();

var Message =
/*#__PURE__*/
function () {
  function Message(pahoMessage) {
    _classCallCheck(this, Message);

    this._pahoMessage = pahoMessage;
  }

  _createClass(Message, [{
    key: "toString",
    value: function toString() {
      return this._pahoMessage.payloadString;
    }
  }, {
    key: "topic",
    get: function get() {
      return this._pahoMessage.destinationName;
    }
  }, {
    key: "json",
    get: function get() {
      try {
        return JSON.parse(this.string);
      } catch (err) {}
    }
  }, {
    key: "string",
    get: function get() {
      return this._pahoMessage.payloadString;
    }
  }, {
    key: "bytes",
    get: function get() {
      return this._pahoMessage.payloadBytes;
    }
  }, {
    key: "qos",
    get: function get() {
      return this._pahoMessage.qos;
    }
  }, {
    key: "dup",
    get: function get() {
      return this._pahoMessage.duplicate;
    }
  }, {
    key: "retain",
    get: function get() {
      return this._pahoMessage.retained;
    }
  }]);

  return Message;
}();

function makePahoMessage(topic, payload) {
  var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (_typeof(payload) === 'object' && !isBuffer(payload)) {
    payload = JSON.stringify(payload);
  }

  var message = new Paho.Message(payload);
  message.destinationName = topic;
  message.qos = opts.qos || 0;
  message.retained = !!(opts.retain || opts.retained);
  return message;
}

function isBuffer(value) {
  return value instanceof ArrayBuffer || ArrayBuffer.isView(value);
}

function pahoConnect (paho) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return new Promise(function (resolve, reject) {
    paho.connect(xtend(opts, {
      onSuccess: resolve,
      onFailure: function onFailure(error) {
        return reject(error);
      }
    }));
  });
}

var ERROR = {
  OK: 0,
  CONNECT_TIMEOUT: 1,
  SUBSCRIBE_TIMEOUT: 2,
  UNSUBSCRIBE_TIMEOUT: 3,
  PING_TIMEOUT: 4,
  INTERNAL_ERROR: 5,
  CONNACK_RETURNCODE: 6,
  SOCKET_ERROR: 7,
  SOCKET_CLOSE: 8,
  MALFORMED_UTF: 9,
  UNSUPPORTED: 10,
  INVALID_STATE: 11,
  INVALID_TYPE: 12,
  INVALID_ARGUMENT: 13,
  UNSUPPORTED_OPERATION: 14,
  INVALID_STORED_DATA: 15,
  INVALID_MQTT_MESSAGE_TYPE: 16,
  MALFORMED_UNICODE: 17,
  BUFFER_FULL: 18
};

var ClientError =
/*#__PURE__*/
function (_Error) {
  _inherits(ClientError, _Error);

  function ClientError(code, message) {
    var _this;

    _classCallCheck(this, ClientError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ClientError).call(this, message));
    _this.code = code;

    _this.is = function (code) {
      return _this.code === code;
    };

    _this.occurred = function () {
      return _this.code !== 0;
    };

    return _this;
  }

  return ClientError;
}(_wrapNativeSuper(Error));

var Client =
/*#__PURE__*/
function () {
  function Client(_ref) {
    var paho = _ref.paho,
        pahoOpts = _ref.pahoOpts;

    _classCallCheck(this, Client);

    this._paho = paho;
    this._pahoOpts = pahoOpts;
    this._subscriptions = {};
    this._emitter = new EventEmitter();
    paho.onMessageArrived = this._handleOnMessage.bind(this);
    paho.onMessageDelivered = this._handleOnSent.bind(this);
    paho.onConnectionLost = this._handleOnClose.bind(this);
  }

  _createClass(Client, [{
    key: "isConnected",
    value: function isConnected() {
      return this._paho.isConnected();
    }
  }, {
    key: "_handleOnMessage",
    value: function _handleOnMessage(pahoMessage) {
      var message = new Message(pahoMessage);
      var topic = message.topic;

      this._emitter.emit("message:".concat(topic), message);

      this._emitter.emit('message', topic, message);
    }
  }, {
    key: "_handleOnSent",
    value: function _handleOnSent(pahoMessage) {
      var message = new Message(pahoMessage);
      var topic = message.topic;

      this._emitter.emit("sent:".concat(topic), message);

      this._emitter.emit('sent', topic, message);
    }
  }, {
    key: "_handleOnClose",
    value: function _handleOnClose(_ref2) {
      var errorCode = _ref2.errorCode,
          errorMessage = _ref2.errorMessage,
          reconnect = _ref2.reconnect;
      var err = new ClientError(errorCode, errorMessage);

      if (reconnect) {
        this._emitter.emit('reconnect', err);
      } else {
        this._emitter.emit('close', err);
      } // for error handling


      if (!err.occurred()) return;

      if (!this._emitter.has('error')) {
        throw err;
      } else {
        this._emitter.emit('error', err);
      }
    }
  }, {
    key: "on",
    value: function on(eventName, listener) {
      this._emitter.on(eventName, listener);
    }
  }, {
    key: "onMessage",
    value: function onMessage(topic, listener) {
      this.on("message:".concat(topic), listener);
    }
  }, {
    key: "onSent",
    value: function onSent(topic, listener) {
      this.on("sent:".concat(topic), listener);
    }
  }, {
    key: "once",
    value: function once(eventName, listener) {
      this._emitter.once(eventName, listener);
    }
  }, {
    key: "off",
    value: function off(eventName, listener) {
      this._emitter.off(eventName, listener);
    }
  }, {
    key: "removeMessageListener",
    value: function removeMessageListener(topic, listener) {
      this.off("message:".concat(topic), listener);
    }
  }, {
    key: "removeSentListener",
    value: function removeSentListener(topic, listener) {
      this.off("sent:".concat(topic), listener);
    }
  }, {
    key: "subscribe",
    value: function subscribe(topic) {
      this._paho.subscribe(topic);

      return this._subscriptions[topic] || (this._subscriptions[topic] = new Subscription(topic, this));
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe(topic) {
      var removeListeners = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      this._paho.unsubscribe(topic);

      delete this._subscriptions[topic];
      if (removeListeners) this.removeMessageListener(topic);
    }
  }, {
    key: "subscribed",
    value: function subscribed() {
      return Object.keys(this._subscriptions);
    }
  }, {
    key: "send",
    value: function send(topic, payload, opts) {
      this._paho.send(makePahoMessage(topic, payload, opts));
    }
    /**
    * @alias this.send
    */

  }, {
    key: "publish",
    value: function publish() {
      this.send.apply(this, arguments);
    }
  }, {
    key: "disconnect",
    value: function disconnect() {
      this._paho.disconnect();
    }
  }, {
    key: "reconnect",
    value: function reconnect() {
      var _this = this;

      this._emitter.emit('reconnect', new ClientError(ERROR.OK, 'No error.'));

      return pahoConnect(this._paho, this._pahoOpts).then(function () {
        _this.subscribed().forEach(function (topic) {
          return _this.subscribe(topic);
        });
      });
    }
  }, {
    key: "host",
    get: function get() {
      return this._paho.host;
    }
  }, {
    key: "port",
    get: function get() {
      return this._paho.port;
    }
  }, {
    key: "path",
    get: function get() {
      return this._paho.path;
    }
  }, {
    key: "uri",
    get: function get() {
      return this._paho.uri;
    }
  }, {
    key: "clientId",
    get: function get() {
      return this._paho.clientId;
    }
  }]);

  return Client;
}();

function connect() {
  var userOpts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var Ctor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Client;

  if (typeof Ctor !== 'function') {
    throw new TypeError('The second argument must be a function, or a constructor.');
  }

  if (typeof userOpts === 'string') userOpts = parseUriToOpts(userOpts);

  var _userOpts = userOpts,
      host = _userOpts.host,
      _userOpts$path = _userOpts.path,
      path = _userOpts$path === void 0 ? '/' : _userOpts$path,
      _userOpts$ssl = _userOpts.ssl,
      ssl = _userOpts$ssl === void 0 ? false : _userOpts$ssl,
      _userOpts$clientId = _userOpts.clientId,
      clientId = _userOpts$clientId === void 0 ? 'mqtt_' + Math.random().toString(16).substr(2, 8) : _userOpts$clientId,
      _userOpts$keepalive = _userOpts.keepalive,
      keepalive = _userOpts$keepalive === void 0 ? 60 : _userOpts$keepalive,
      _userOpts$port = _userOpts.port,
      port = _userOpts$port === void 0 ? ssl ? 443 : 80 : _userOpts$port,
      hosts = _userOpts.hosts,
      will = _userOpts.will,
      username = _userOpts.username,
      etcOpts = _objectWithoutProperties(_userOpts, ["host", "path", "ssl", "clientId", "keepalive", "port", "hosts", "will", "username"]);

  var pahoOpts = {
    useSSL: ssl,
    keepAliveInterval: keepalive
  };

  if (!host) {
    if (hosts && hosts.length > 0) {
      host = hosts[0];
    } else {
      throw new TypeError('`host` option is required!');
    }
  }

  if (host.slice(-1) === '/') host = host.slice(0, -1);
  if (path[0] !== '/') path = '/' + path;
  if (will) pahoOpts.will = wrapPahoWill(will);
  if (username) pahoOpts.userName = username;
  if (hosts) pahoOpts.hosts = hosts;
  xtend$1(pahoOpts, etcOpts);
  var paho = new Paho.Client(host, port, path, clientId);
  return pahoConnect(paho, pahoOpts).then(function () {
    return createClient(Ctor, {
      paho: paho,
      pahoOpts: pahoOpts
    });
  });
}

function wrapPahoWill(_ref) {
  var topic = _ref.topic,
      payload = _ref.payload,
      opts = _objectWithoutProperties(_ref, ["topic", "payload"]);

  return makePahoMessage(topic, payload, opts);
}

function createClient(Ctor, setting) {
  return Client === Ctor || Ctor.prototype instanceof Client ? new Ctor(setting) : Ctor(setting);
}

function parseUriToOpts(str) {
  var regexp = /^((wss?):\/\/)?([^/]+?)(:(\d+))?(\/.*)?$/;

  var _str$match = str.match(regexp),
      _str$match2 = _slicedToArray(_str$match, 7),
      protocol = _str$match2[2],
      host = _str$match2[3],
      port = _str$match2[5],
      path = _str$match2[6];

  return {
    ssl: protocol === 'wss',
    port: port && parseInt(port),
    host: host,
    path: path
  };
}

exports.connect = connect;
exports.Client = Client;
exports.ERROR = ERROR;
